<template>
    <div class="container">
        <form action="" >
            <div class="title">
                <h2 class="title">Edit</h2> 
            </div>
            <div class="content">
                <!-- Change properties -->
                <div class="changeproperties">
                        <div class="columns">
                            <div class="column is-1">
                                    <h6 style="margin-bottom:0px;margin-right:5px"  > Project
                                    <span class="attention"> * </span>
                                    </h6>
                                     
                            </div>
                            <div class="column is-10">
                                 <b-select placeholder="Select a project" v-model="project" >
                                            <option v-for="(item,key) in taskProject" :key="key">{{item.nameproject}}</option>  
                                        </b-select> 
                            </div>
                            <div class="columns is-1">
                                <span class="private">
                                    <input type="checkbox" name="" id="" value="true">
                                    <label for="">Private</label>
                                </span>
                            </div>
                        </div>  
                        <div class="columns"> 
                            <div class="column is-1">
                                <h6 style="margin-right:5px">
                                  Tracker
                                  <span class="attention">*</span>
                                </h6>
                            </div>
                            <div class="column is-10">
                                <b-select placeholder="Select a tracker" v-model="tracker">
                                    <option v-for="(item,key) in taskTracker" :key="key">{{item.name}}</option>
                                </b-select>
                            </div>
                        </div>   
                        <div class="columns">
                            <div class="column is-1">
                                <h6 style="margin-bottom:0px;margin-right:5px" >Subject
                                    <span class="attention"> * </span>
                                </h6>  
                            </div>
                            <div class="column is-10">
                                <b-field 
                                    :type="{'is-danger': hasError }"
                                    :message="{'Project is not available':hasError }">
                                    <b-input class="input-lage" v-model="subject"  type="text" />
                                </b-field>
                            </div>
                        </div>
                        <div class="columns"> 
                            <div class="column">
                                <b-field style="margin-right:5px" label="Description">
                                </b-field>
                                <a href=""><i class="fas fa-pen"></i> Edit</a>
                            </div>
                        </div>   
                        <div class="columns input-select">
                            <div class="column is-haft">
                                <div class="columns">
                                    <div class="column is-2">
                                     <h6>Status
                                          <span class="attention"> * </span>
                                    </h6>
                                    </div>
                                    <div class="column is-8">
                                        <b-select placeholder="Select a status" v-model="status">
                                            <option v-for="(item,key) in taskStatus" :key="key">{{item.status}}</option>
                                            
                                        </b-select>
                                    </div>
                                </div>
                            </div>
                            <div class="column is-half">
                                <div class="columns">
                                    <div class="column is-2">
                                        <h6>Parent task
                                            <span class="attention">*</span>
                                        </h6>
                                    </div>
                                    <div class="column is-8">
                                        <b-field 
                                            :type="{'is-danger': hasError }"
                                            :message="{'Parent task is not available':hasError }">
                                            <b-input placeholder="Search..."
                                            v-model="parenttask"
                                            type="search"
                                            icon="magnify"
                                            ></b-input> 
                                        </b-field>
                                    </div> 
                                </div>
                            </div>
                        </div>
                        <div class="columns input-select">
                            <div class="column is-half">
                                <div class="columns">
                                    <div class="column is-2">
                                        <h6>Priority
                                            <span class="attention">*</span>
                                        </h6>
                                    </div>
                                    <div class="column is-8">
                                        <b-select placeholder="Select a priority" v-model="priority">
                                        <option>Normal</option>
                                        </b-select>
                                    </div>
                                </div>  
                            </div>
                            <div class="column is-half">
                                <div class="columns">
                                    <div class="column is-2">
                                        <h6>Start date
                                            <span class="attention">*</span>
                                        </h6>
                                    </div>
                                    <div class="column is-8">
                                        <b-input 
                                        placeholder="Start date"
                                        type="date" 
                                        v-model="start_date"
                                        ></b-input>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="columns input-select">
                            <div class="column is-half">
                                <div class="columns">
                                    <div class="column is-2">
                                        <h6>Assignee
                                            <span class="attention">*</span>
                                        </h6>
                                    </div>
                                    <div class="column is-8">
                                        <b-select placeholder="Select a assignee" v-model="assignee">
                                            <option v-for="(item,key) in taskAssignee" :key="key">{{item.name}}</option>
                                        </b-select>
                                    </div>
                                </div>  
                            </div>
                            <div class="column is-half">
                                <div class="columns" >
                                    <div class="column is-2">
                                        <h6>Due date
                                            <span class="attention">*</span>
                                        </h6>
                                    </div>
                                    <div class="column is-8">
                                        <b-input type="date"  v-model="duedate"></b-input>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="columns input-select">
                            <div class="column is-half">
                            </div>
                            <div class="column is-6 ">
                                <div class="columns">
                                    <div class="column is-2">
                                        <h6>Estimated time
                                            <span class="attention">*</span>
                                        </h6>
                                    </div>
                                    <div class="column is-8">
                                        <b-input type="time" name="" id="" v-model="estimated"></b-input>
                                    </div>
                                    <span>Hours</span>
                                </div>
                            </div>
                        </div>
                        <div class="columns input-select">
                            <div class="column is-6"></div>
                            <div class="column is-half">
                                <div class="columns">
                                     <div class="column is-2">
                                        <h6>% Done
                                            <span class="attention">*</span>
                                        </h6>
                                    </div>
                                    <div class="column ">
                                        <b-select placeholder="Select a Done" v-model="done">
                                            <option>100%</option>
                                            <option>90%</option>
                                            <option>80%</option>
                                            <option>70%</option>
                                            <option>60%</option>
                                        </b-select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- <div class="row">
                            <div class="col-2 col-md-1  auto">
                                <label for="">Sprint</label><span class="attention"> * </span>
                            </div>
                            <div class="col-5 col-md-4">
                                <input type="number" >
                            </div>
                            <div class="col-3 col-md-2  auto">
                                <label for="" class="label-time">Point</label>
                            </div>
                            <div class="col-5 col-md-5">
                                <input type="number" name="" id="">
                            </div>
                        </div>                   -->
                                
                </div>
            <!-- Long time -->
            <!-- <b-field label="Long Time" :label-position="labelPosition">
                <div class="longtime">
                    <div class="container">
                        <div class="row">
                            <div class="col-2 col-md-1 auto">
                             <label for="">Spent time</label>
                            </div>
                            <div class="col-5 col-md-5">
                                <input type="text"><span>Hours</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-2 col-md-1">
                                <label for="">Comments</label>
                            </div>
                            <div class="col-10 col-md-10">
                                <input class="input-lage" type="text" name="" id="">
                            </div>
                        </div>
                    </div>
                </div>
            </b-field> -->
            <!-- Notes -->
                <div class="notes">
                    <div class="container">
                        <div class="column">
                            <b-button type="button" class="btn-event-word" @click="eventBold"><i class="fas fa-bold"></i></b-button>
                            <b-button type="button" class="btn-event-word" @click="eventItalic"><i class="fas fa-italic"></i> </b-button>
                            <b-button type="button" class="btn-event-word" @click="eventUnderline"><i class="fas fa-underline"></i></b-button>
                            <b-button type="button" class="btn-event-word"><i class="fas fa-strikethrough"></i></b-button>
                            <b-button type="button" class="btn-event-word"><p style="font-weight: bold;margin-bottom: 0px;">C</p></b-button>
                            <b-button type="button" class="btn-event-word"><p style="font-weight: bold;margin-bottom: 0px;">H1</p></b-button>
                            <b-button type="button" class="btn-event-word"><p style="font-weight: bold;margin-bottom: 0px;">H2</p></b-button>
                            <b-button type="button" class="btn-event-word"><p style="font-weight: bold;margin-bottom: 0px;">H3</p></b-button>
                            <b-button type="button" class="btn-event-word"><i class="fas fa-list-ul"></i> </b-button>
                            <b-button type="button" class="btn-event-word"><i class="fas fa-list-ol"></i> </b-button>
                            <b-button type="button" class="btn-event-word"><i class="fas fa-indent"></i> </b-button>
                            <b-button type="button" class="btn-event-word"><i class="fas fa-outdent"></i> </b-button>
                            <b-button type="button" class="btn-event-word"><p style="font-weight: bold;margin-bottom: 0px;">pre</p> </b-button>
                            <b-button type="button" class="btn-event-word"><p style="font-weight:bold" value="">></p></b-button>
                            <b-button type="button" class="btn-event-word"><i class="fas fa-image"></i> </b-button>
                        </div>
                        <div class="columns">
                            <textarea class="text" :class="{fontweight:isShow,italic:italic,underline:underline}" rows="10"></textarea>
                        </div>
                    </div>
                    <div class="private-note"><input type="checkbox" name="" id=""><label for="">Private notes</label></div>
                </div>
           
            <!-- files -->
                    <div class="columns input-file" >
                        <div class="column is-4"><input type="file" class="btn-input" id="exampleFormControlFile1">
                        </div>
                        <div class="column is-3"><span><p>(Maximum size: 500MB)</p></span></div>
                        <div class="column is-3"></div>
                        <div class="column is-2"><a href="">Edit attached files</a></div>
                    </div>
            </div>
            <!-- button submit  -->
            <button class="button is-success btn" type="submit" @click.prevent="submit" >Save</button> 
            <button class="button is-danger btn" type="button" @click.prevent="">Reset</button>
        </form> 
    </div>
</template>
<script>
import { constants } from 'crypto';
import axios from 'axios'
import callApi from './../middleware/apiCaller.js'
    export default {
        data() {
            return {
                labelPosition: 'on-border',
                taskProject:[],
                taskAssignee:[],
                taskTracker:[],
                taskStatus:[],
                items:'',
                selected:'12312',
                start_date:'',
                duedate:'',
                estimated:'',
                parenttask:'',
                priority:'',
                isShow:false,
                italic:false,
                underline:false,
                project:'',
                status:'',
                tracker:'',
                done:'',
                subject:'',
                assignee:'',
                hasError : false
            }
        },
        mounted(){
            callApi('project','GET', null).then(res =>{
                this.taskProject= res.data
            })
            callApi('assignee','GET',null).then(res =>{
                this.taskAssignee=res.data
            })
            callApi('tracker','GET', null).then(res =>{
                this.taskTracker=res.data
            })
            callApi('status','GET',null).then(res =>{
                this.taskStatus=res.data
            })
        },
        props:['tasks'],
        methods:{
            eventBold(){
               this.isShow=!this.isShow;
            },

            eventItalic(){
                this.italic=!this.italic
            },

            eventUnderline(){
                this.underline=!this.underline
            },
            
            getTracker(tracker){
                for( let i=0 ; i < this.taskTracker.length ; i++){
                    if(this.taskTracker[i].name===tracker){
                        return this.taskTracker[i].id
                    }
                }
            },

            getStatus(status){
                for(let i=0; i < this.taskStatus.length; i++){
                    if(this.taskStatus[i].status===status){
                        return this.taskStatus[i].id
                    }
                }
            },

            getAssignee(assignee){
                for(let i = 0; i < this.taskAssignee.length; i++){
                    if(this.taskAssignee[i].name===assignee){
                        return this.taskAssignee[i].id
                    }
                }
            },

            submit(){
                if(this.project!==''||this.tracker!==''){
                    callApi('tasks','POST',{
                    id:'',
                    project:this.project,
                    tracker:this.getTracker(this.tracker),
                    subject:this.subject,
                    status:this.getStatus(this.status),
                    priority:this.priority,
                    assignee:this.getAssignee(this.assignee),
                    start_date:this.start_date,
                    duedate:this.duedate,
                    estimated:this.estimated,
                    done: this.done
                }).then((res)=>{
                    alert('You were post up server')
                })
                }else{ 
                    this.hasError=!this.hasError
                    alert('Vui lòng nhập đầy đủ các trường')
                    }
                
            },
            resetText(){
                this.project='',
                this.tracker='',
                this.status='',
                this.subject='',
                this.done='',
                this.assignee=''
                this.priority='',
                this.start_date='',
                this.duedate='',
                this.estimated=''
            }
        },
        watch:{
            
        }
    }
</script>
<style scoped>
*{
    margin: 0px 0px;
    padding: 0px 0px;
}
.container{
    margin: 5px 5px;
}
.fontweight{
    font-weight: bold;
}
.italic{
    font-style: italic;
}
.underline{
    text-decoration:underline;
}

.attention{
    color: red;
    font-weight: unset
}
.input-file{
    width:80%;
    height:30px; 
    margin:1% 2%;
}
.title{
    margin: 0;
}
.content{
    height:auto;
    width: 100%;
    margin-left: 10%;
}
/* change properties css */
.changeproperties{
    margin: 5% 3%;
}
/* Notes css */
.notes{
    margin: 3% 1%;
    height:auto;
    width: 98%;
}
.flie button{
    margin: 10px 10px;
}
.file{
    margin: 1% 1%;
    height:30%;
    width: 98%;
    border-radius:5px;
}
.private{
    float: right;
}
.input-parent{
   position: absolute;
   padding-left: 20px;
}

.input-lage{
    width:100%;
}
textarea{
    margin: 5px 5px;
    width: 90%;
}
.btn-event-word{
    font-size: 12px;
    justify-content: center;
    width: 30px;
    height: 30px;
    margin: 5px 5px;
}
.private-note{
    margin: 5px 10px;
}
.field{
    margin-right: 25px;
}
.is-success{
    width: 70px;
    height: 40px ;
}
.title{
    font-size: 90px;
    margin-left: 6%;
    text-align: center;
}
.btn{
    height: 50px;
    width: 200px;
    margin-bottom: 5%;
    margin-left:23%;
    font-size: 25px
}
.btn-input{
    display: block;
    height: 40px;
    width: 100%;
}
.input-select{
    margin-bottom: 25px;
}
</style>
